> ## Documentation Index
> Fetch the complete documentation index at: https://developer.sandbox.co.in/llms.txt
> Use this file to discover all available pages before exploring further.

# GSTR-2A CDNA

> Get all amended credit/debit notes in GSTR-2A for a return period for authenticated taxpayer

#### Response schema

For successful responses, these resources describe the GSTN payload at `data.data`.

<Card title="View JSON schema" icon="code" href="https://raw.githubusercontent.com/in-co-sandbox/in-co-sandbox-docs/refs/heads/main/data/gst/schema/request/taxpayer/gstr-2a/cdna.json" arrow="true" horizontal />

<Card title="View Excel field reference" icon="file-spreadsheet" href="https://raw.githubusercontent.com/in-co-sandbox/in-co-sandbox-docs/refs/heads/main/data/gst/schema/workbook/taxpayer/gstr-2a/cdna-v2.0.xlsx" arrow="true" horizontal />


## OpenAPI

````yaml api-reference/gst/compliance/openapi.json GET /gst/compliance/tax-payer/gstrs/gstr-2a/cdna/{year}/{month}
openapi: 3.0.1
info:
  title: compliance
  description: >-
    **GST Compliance API** enables businesses to automate compliance
    requirements like [Taxpayer
    verification](https://developer.sandbox.co.in/reference/search-gstin-api),
    [GSTR
    Filing](https://developer.sandbox.co.in/reference/gst-taxpayer-authentication),
    [Generating
    E-Invoices](https://developer.sandbox.co.in/reference/e-invoice-authentication-api),
    and [E-Way
    Bills](https://developer.sandbox.co.in/reference/e-way-bill-authentication-api).We
    provide these APIs from GSTN-authorised GST Suvidha Providers, handling the
    encryption-decryption and signing so you don't have to handle the
    complexities.
  version: 1.0.0
servers:
  - url: https://api.sandbox.co.in
  - url: https://test-api.sandbox.co.in
security: []
tags:
  - name: Public
  - name: Taxpayer
  - name: Taxpayer Auth
  - name: Returns
  - name: GSTR-1 Documents
  - name: File GSTR-1
  - name: GSTR-2A Documents
  - name: GSTR-2B Document
  - name: File GSTR-3B
  - name: GSTR-4
  - name: File GSTR-9
  - name: Invoice Management System
  - name: GSTR-1A Documents
  - name: File GSTR-1A
  - name: Ledgers
  - name: e-Invoice
  - name: Sales e-Invoices for return period
  - name: Purchase e-Invoices for return period
  - name: Front Office Notices
  - name: Front Office
  - name: AATO
  - name: e-Invoice1
  - name: Authentication
  - name: e-Invoice12
  - name: E-Way Bill
  - name: E-Way Bill1
  - name: Authentication1
  - name: Consignor
  - name: Consolidated E-Way Bill
  - name: Multi-Vehicle Movement
  - name: Consignee
  - name: Transporter
  - name: Consolidated E-Way Bill1
  - name: Multi-vehicle Movement
  - name: Common
paths:
  /gst/compliance/tax-payer/gstrs/gstr-2a/cdna/{year}/{month}:
    get:
      tags:
        - Taxpayer
        - Returns
        - GSTR-2A Documents
      summary: GSTR-2A CDNA
      description: >-
        Get all amended credit/debit notes in GSTR-2A for a return period for
        authenticated taxpayer
      operationId: getGstr2aCdna
      parameters:
        - name: year
          in: path
          description: ''
          required: true
          example: ''
          schema:
            type: string
        - name: month
          in: path
          description: ''
          required: true
          example: ''
          schema:
            type: string
        - name: counterparty_gstin
          in: query
          description: Filter by supplier / counterparty GSTIN
          required: false
          schema:
            type: string
            example: '{{ctin}}'
        - name: authorization
          in: header
          description: >-
            GST taxpayer access token. For token-generation steps, refer to the
            [Generate Taxpayer
            Session](/recipes/gst/authentication/generate_tax_payer_session)
            recipe, then pass the token in the authorization header.
          required: true
          example: ''
          schema:
            type: string
        - name: x-api-version
          in: header
          description: API version
          required: false
          example: ''
          schema:
            type: string
            default: 1.0.0
        - name: x-api-key
          in: header
          description: API key for identification
          required: true
          example: ''
          schema:
            type: string
      responses:
        '200':
          description: 200 Success / RET13509 No data found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetGstr2aCdnaResponse'
              examples:
                200 Success:
                  summary: 200 Success
                  value:
                    code: 200
                    data:
                      status_cd: '1'
                      data:
                        cdna:
                          - cfs: 'Y'
                            ctin: 01ABCAP1123Q1ZS
                            nt:
                              - chksum: AflJufPlFStqKBZ
                                d_flag: 'Y'
                                diff_percent: 0.65
                                idt: 20-09-2023
                                inum: '915914'
                                inv_typ: R
                                itms:
                                  - itm_det:
                                      camt: 614.44
                                      csamt: 621.09
                                      iamt: 0
                                      rt: 10.1
                                      samt: 5.68
                                      txval: 6210.99
                                    num: 1
                                nt_dt: 23-12-2023
                                nt_num: '533515'
                                ntty: C
                                ont_dt: 23-09-2023
                                ont_num: '533515'
                                p_gst: 'N'
                                pos: '06'
                                rchrg: 'N'
                                val: 729248.16
                    timestamp: 1763446641000
                    transaction_id: 182ebce6-df57-4be7-9b07-2d9936a17550
                RET13509 No data found:
                  summary: RET13509 No data found
                  value:
                    code: 200
                    data:
                      status_cd: '0'
                      error:
                        error_cd: RET13509
                        message: No document found for the provided Inputs
                    timestamp: 1763446641000
                    transaction_id: c65a8035-bbe6-4ffa-a70a-7f70ea79906b
          headers: {}
      deprecated: false
      security: []
components:
  schemas:
    GetGstr2aCdnaResponse:
      oneOf:
        - $ref: '#/components/schemas/GetGstr2aCdnaSuccessResponse'
        - $ref: '#/components/schemas/GstnBusinessErrorResponse'
      description: >-
        A GSTN success or GSTN business-failure response. Both variants use HTTP
        200.
    GetGstr2aCdnaSuccessResponse:
      allOf:
        - $ref: '#/components/schemas/TaxpayerResponseMetadata'
        - type: object
          required:
            - data
          properties:
            data:
              type: object
              description: The GSTN success wrapper.
              required:
                - status_cd
                - data
              properties:
                status_cd:
                  type: string
                  enum:
                    - '1'
                  description: GSTN success status.
                  example: '1'
                data:
                  $ref: '#/components/schemas/GetGstr2aCdnaSuccessPayload'
    GstnBusinessErrorResponse:
      type: object
      description: HTTP 200 response containing a GSTN business failure.
      required:
        - code
        - timestamp
        - transaction_id
        - data
      properties:
        code:
          type: integer
          description: The HTTP status code reported in the response body.
          enum:
            - 200
          example: 200
        timestamp:
          type: integer
          format: int64
          description: The response timestamp in Unix epoch milliseconds.
          example: 1763446641000
        transaction_id:
          type: string
          description: The transaction identifier used to trace the request.
          example: 41bb8041-fb83-4654-8d75-85a19f329158
        data:
          type: object
          description: The GSTN business-failure wrapper.
          required:
            - status_cd
            - error
          properties:
            status_cd:
              type: string
              enum:
                - '0'
              description: GSTN business-failure status.
              example: '0'
            error:
              $ref: '#/components/schemas/GstnBusinessError'
    TaxpayerResponseMetadata:
      type: object
      description: Fields included in every taxpayer endpoint response.
      required:
        - code
        - timestamp
        - transaction_id
      properties:
        code:
          type: integer
          description: The HTTP status code reported in the response body.
          enum:
            - 200
          example: 200
        timestamp:
          type: integer
          format: int64
          description: The response timestamp in Unix epoch milliseconds.
          example: 1763446641000
        transaction_id:
          type: string
          description: The transaction identifier used to trace the request.
          example: 41bb8041-fb83-4654-8d75-85a19f329158
    GetGstr2aCdnaSuccessPayload:
      type: object
      description: Successful GSTN payload for Get Gstr2a Cdna.
      properties:
        cdna:
          type: array
          description: The cdna value returned by GSTN.
          items:
            type: object
            properties:
              cfs:
                type: string
                description: R1_Fil_Status
              cfs3b:
                type: string
                description: R3B_Fil_Status
              dtcancel:
                type: string
                description: Date of cancellation of supplier
              fldtr1:
                type: string
                description: Date of filing GSTR1/5 of supplier
              flprdr1:
                type: string
                description: Filing period of GSTR1/5 of supplier
              ctin:
                type: string
                description: Counter party gstin
              nt:
                type: array
                description: The nt value returned by GSTN.
                items:
                  type: object
                  properties:
                    chksum:
                      type: string
                      description: Checksum
                    idt:
                      type: string
                      description: Involice date
                    inum:
                      type: string
                      description: Involice number
                    val:
                      type: number
                      description: Note Value
                    pos:
                      type: string
                      description: >-
                        Maintained in GST System common database POS as provided
                        in law / actual provision  of service.
                    rchrg:
                      type: string
                      description: Reverse Charge
                    inv_typ:
                      type: string
                      description: tax payer action
                      enum:
                        - R
                        - DE
                        - SEWP
                        - SEWOP
                        - CBW
                    d_flag:
                      type: string
                      description: delink flag
                    itms:
                      type: array
                      description: The itms value returned by GSTN.
                      items:
                        type: object
                        properties:
                          itm_det:
                            type: object
                            description: The itm det value returned by GSTN.
                            properties:
                              camt:
                                type: number
                                description: CGST amount
                              csamt:
                                type: number
                                description: CESS amount
                              iamt:
                                type: number
                                description: IGST amount
                              samt:
                                type: number
                                description: SGST amount
                              txval:
                                type: number
                                description: Taxval amount
                              rt:
                                type: number
                                description: Tax rate
                          num:
                            type: integer
                            description: Item number
                    nt_dt:
                      type: string
                      description: note date
                    nt_num:
                      type: string
                      description: note number
                    ont_dt:
                      type: string
                      description: original note date
                    ont_num:
                      type: string
                      description: original note number
                    aspd:
                      type: string
                      description: Original period in which invoice was added
                    atyp:
                      type: string
                      description: flag to determine type of amendment
                    p_gst:
                      type: string
                      description: Pre GST Regime Dr./ Cr. Notes
                    ntty:
                      type: string
                      description: note type
                    diff_percent:
                      type: number
                      description: Differential percentage
    GstnBusinessError:
      type: object
      description: A business error returned by GSTN.
      required:
        - error_cd
        - message
      properties:
        error_cd:
          type: string
          description: The GSTN business error code.
          example: RET11416
        message:
          type: string
          description: A human-readable description of the GSTN business error.
          example: No records found.

````